
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Understanding how tasks are imported &#8212; huey 2.0.0 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Managing shared resources" href="shared_resources.html" />
    <link rel="prev" title="Consuming Tasks" href="consumer.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="shared_resources.html" title="Managing shared resources"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="consumer.html" title="Consuming Tasks"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">huey 2.0.0 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="understanding-how-tasks-are-imported">
<span id="imports"></span><h1>Understanding how tasks are imported<a class="headerlink" href="#understanding-how-tasks-are-imported" title="Permalink to this headline">¶</a></h1>
<p>Behind-the-scenes when you decorate a function with <a class="reference internal" href="api.html#Huey.task" title="Huey.task"><code class="xref py py-meth docutils literal notranslate"><span class="pre">task()</span></code></a> or
<a class="reference internal" href="api.html#Huey.periodic_task" title="Huey.periodic_task"><code class="xref py py-meth docutils literal notranslate"><span class="pre">periodic_task()</span></code></a>, the function registers itself with an in-memory
registry. When a task function is called, a reference is put into the queue,
along with the arguments the function was called with, etc. The message is then
read by the consumer, and the task function is looked-up in the consumer’s
registry.  Because of the way this works, it is strongly recommended
that <strong>all decorated functions be imported when the consumer starts up</strong>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If a task is not recognized, the consumer will raise a
<a class="reference internal" href="api.html#HueyException" title="HueyException"><code class="xref py py-class docutils literal notranslate"><span class="pre">HueyException</span></code></a>.</p>
</div>
<p>The consumer is executed with a single required parameter – the import path to
a <a class="reference internal" href="api.html#Huey" title="Huey"><code class="xref py py-class docutils literal notranslate"><span class="pre">Huey</span></code></a> object.  It will import the Huey instance along with
anything else in the module – thus you must be sure <strong>imports of your tasks
occur with the import of the Huey object</strong>.</p>
<div class="section" id="suggested-organization-of-code">
<h2>Suggested organization of code<a class="headerlink" href="#suggested-organization-of-code" title="Permalink to this headline">¶</a></h2>
<p>Generally, I structure things like this, which makes it very easy to avoid
circular imports.</p>
<ul>
<li><p class="first"><code class="docutils literal notranslate"><span class="pre">config.py</span></code>, the module containing the <a class="reference internal" href="api.html#Huey" title="Huey"><code class="xref py py-class docutils literal notranslate"><span class="pre">Huey</span></code></a> object.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># config.py</span>
<span class="kn">from</span> <span class="nn">huey</span> <span class="kn">import</span> <span class="n">RedisHuey</span>

<span class="n">huey</span> <span class="o">=</span> <span class="n">RedisHuey</span><span class="p">(</span><span class="s1">&#39;testing&#39;</span><span class="p">)</span>
</pre></div>
</div>
</li>
<li><p class="first"><code class="docutils literal notranslate"><span class="pre">tasks.py</span></code>, the module containing any decorated functions.  Imports the
<code class="docutils literal notranslate"><span class="pre">huey</span></code> object from the <code class="docutils literal notranslate"><span class="pre">config.py</span></code> module:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># tasks.py</span>
<span class="kn">from</span> <span class="nn">config</span> <span class="kn">import</span> <span class="n">huey</span>

<span class="nd">@huey.task</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">b</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">a</span> <span class="o">+</span> <span class="n">b</span>
</pre></div>
</div>
</li>
<li><p class="first"><code class="docutils literal notranslate"><span class="pre">main.py</span></code> / <code class="docutils literal notranslate"><span class="pre">app.py</span></code>, the “main” module.  Imports both the <code class="docutils literal notranslate"><span class="pre">config.py</span></code>
module <strong>and</strong> the <code class="docutils literal notranslate"><span class="pre">tasks.py</span></code> module.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># main.py</span>
<span class="kn">from</span> <span class="nn">config</span> <span class="kn">import</span> <span class="n">huey</span>  <span class="c1"># import the &quot;huey&quot; object.</span>
<span class="kn">from</span> <span class="nn">tasks</span> <span class="kn">import</span> <span class="n">add</span>  <span class="c1"># import any tasks / decorated functions</span>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">add</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
    <span class="k">print</span><span class="p">(</span><span class="s1">&#39;1 + 2 = </span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">result</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">blocking</span><span class="o">=</span><span class="bp">True</span><span class="p">))</span>
</pre></div>
</div>
</li>
</ul>
<p>To run the consumer, point it at <code class="docutils literal notranslate"><span class="pre">main.huey</span></code>, in this way, both the <code class="docutils literal notranslate"><span class="pre">huey</span></code>
instance <strong>and</strong> the task functions are imported in a centralized location.</p>
<div class="highlight-console notranslate"><div class="highlight"><pre><span></span><span class="gp">$</span> huey_consumer.py main.huey
</pre></div>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Understanding how tasks are imported</a><ul>
<li><a class="reference internal" href="#suggested-organization-of-code">Suggested organization of code</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="consumer.html"
                        title="previous chapter">Consuming Tasks</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="shared_resources.html"
                        title="next chapter">Managing shared resources</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/imports.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="shared_resources.html" title="Managing shared resources"
             >next</a> |</li>
        <li class="right" >
          <a href="consumer.html" title="Consuming Tasks"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">huey 2.0.0 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, charles leifer.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.1.
    </div>
  </body>
</html>